$(document).ready(function() {
    $('#formAddress').bootstrapValidator({
        message: 'Este valor no es válido.',
        autoFocus: true,
		feedbackIcons: {
		valid: 'fa fa-check',
		invalid: 'fa fa-times',
		validating: 'fa fa-refresh'
		},
		fields: {
			date: {
                validators: {
                    notEmpty: {
                        message: 'Campo requerido'
                    }
                }
            }
        }
    }).on('success.form.bv', function(form){
        $('#btnsave').button('loading');
    	form.preventDefault();
		var $form = $(form.target).serializeArray(); 
        $form.push({name: "client", value: $('#cdcliente').val() });
		$.ajax({
			url: "direccion.php",
			type: "POST",
			data: $.param($form),
			success: function(data){
                $('#btnsave').button('reset');
                $('#formAddress')[0].reset();
                $('#addressNew').modal('hide');
                $('#address').modal();
			}
		});
	});


    $('#formorden').bootstrapValidator({
        message: 'Este valor no es válido.',
        autoFocus: true,
        feedbackIcons: {
        valid: 'fa fa-check',
        invalid: 'fa fa-times',
        validating: 'fa fa-refresh'
        },
        fields: {
            newName: {
                enabled: false,
                validators: {
                    notEmpty: {
                        message: 'Campo requerido'
                    },
                    stringLength: {
                        min: 7,
                        message: 'Ingrese el nombre completo'
                    }
                }
            },
            newPhone: {
                enabled: false,
                validators: {
                    stringLength: {
                        max: 9,
                        message: 'El numero no debe ser mayor a 9 digitos'
                    },
                    regexp: {
                        regexp: /^\d{4}-\d{4}/,
                        message: 'Ingrese un numero telefonico valido. Formato: 1234-5678'
                    }
                }
            },
            newNIT: {
                enabled: false,
                validators: {
                    stringLength: {
                        max: 9,
                        message: 'El numero no debe ser mayor a 9 digitos'
                    }
                }
            },
            cliente: {
                validators: {
                    notEmpty: {
                        message: 'Campo requerido'
                    }
                }
            },
            cdcliente:{
                validators: {
                    notEmpty: {
                        message: 'Debe selecciona un opcion'
                    },
                    integer: {
                        message: 'El valor no es un entero'
                    }
                }
            },
            pago: {
                validators: {
                    notEmpty: {
                        message: 'Seleccione una opcion'
                    }
                }
            },
            envio: {
                validators: {
                    notEmpty: {
                        message: 'Seleccione una opcion'
                    }
                }
            },
            Enca_Compra: {
                validators: {
                    notEmpty: {
                        message: 'Campo requerido'
                    },
                    stringLength: {
                        min: 4,
                        message: 'Ingrese el nombre completo'
                    }
                }
            }
        }
    }).on('success.form.bv', function(form){
        form.preventDefault();
        var rows = $('#DescripcionO tbody tr').length;
        if (rows < 1) {
            alert("error","debe agregar productos al pedidos");
            return false;
        }
        if ( $('#envioFactura').is(':checked') ) {
            var input = $('#comentario'),
            comentario = input.val();
            input.val(comentario+'\r<em>Enviar factura con producto</em>');
        }
        $('#btnForm').button('loading');
        var $form = $(form.target).serialize();
        $.ajax({
            url: "guardar.php",
            type: "POST",
            data: $form,
            success: function(data){
                $("#resultadosproductos").html(data);
                $('#btnForm').button('reset');
            }
        });
    });

});