$( document ).ready(function() {
var valid_facta = {
    group: '.col-xs-4',
    validators: {
        notEmpty: {
            message: 'Campo requerido'
        }
    }
},
valid_abono = {
    group: '.col-xs-6',
    validators: {
        notEmpty: {
            message: 'Campo requerido'
        },
        numeric : {
            message : 'Introduze un valor valido'
        }
    }
},
Index = 0;

$('#Form_Deposito').bootstrapValidator({
		message: 'Este valor no es válido.',
		feedbackIcons: {
		valid: 'glyphicon glyphicon-ok',
		invalid: 'glyphicon glyphicon-remove',
		validating: 'glyphicon glyphicon-refresh'
		},
		fields: {
			date: {
                validators: {
                    notEmpty: {
                        message: 'Debe selecciona una fecha'
                    },
                    date: {
                        format: 'DD/MM/YYYY',
                        message: 'La fecha no es valida formato: 25/05/2018'
                    }
                }
            },
            newName: {
                enabled: false,
                validators: {
                    notEmpty: {
                        message: 'Campo requerido'
                    },
                    stringLength: {
                        min: 7,
                        message: 'Ingrese el nombre completo'
                    }
                }
            },
			cdcliente: {
				excluded: false,
				group: '.col-sm-10',
				validators: {
					notEmpty: {
						message: 'Seleccione un cliente'
					}
				}
			},
			boleta: {
				validators: {
					notEmpty: {
						message: 'Porfavor introduzca un valor'
					},
					integer: {
                        message: 'El valor debe ser numerico'
                    }
				}
			},
			banco: {
				validators: {
					notEmpty: {
						message: 'Porfavor seleccione un banco'
					}
				}
			},
			total: {
				validators: {
					notEmpty: {
						message: 'Porfavor introduzca una canitdad'
					},
					numeric:{
						message: 'Porfavor introduzca una canitdad'
					}
                }
			},
            'factura[0]': valid_facta,
            'catidad[0]': valid_abono
		}
	}).on('click', '.addButton', function() {

        Index++;
        var $template = $('#Contenedor_Template'), //buscar el div con id = Contenedor_Template
            $clone = $template
                    .clone() //clona el div con todo su contenido
                    .removeClass('hide') //elimina la clase hide
                    .removeAttr('id') // elimina el id ;
                    .attr('data-field-index', Index) //agrega el atributo 'data-field-index' mas el numero de Index
                    .insertBefore($template);
            $clone
                .find('[name="factura"]').attr('name', 'factura[' + Index + ']').removeAttr("disabled").end()//remplaza el atributo nombre y elimina el atributo disable
                .find('[name="catidad"]').attr('name', 'catidad[' + Index + ']').removeAttr("disabled").end();

            $('#Form_Deposito')
                .bootstrapValidator('addField', 'factura[' + Index + ']', valid_facta)//agrega el input a la validacion de bootstrapValidator para ser validado
                .bootstrapValidator('addField', 'catidad[' + Index + ']', valid_abono);//con los parametros de valid_facta y valid_abono


    }).on('click', '.removeButton', function() {

        var $row  = $(this).parents('.form-group'),//busca el div con clase form-group 
            index2 = $row.attr('data-field-index'); //obtiene el atributo data-field-index del div

        $('#Form_Deposito')
                .bootstrapValidator('removeField', $row.find('[name="factura[' + index2 + ']"]'))// elmina los inputs de bootstrapValidator del div de atributo data-field-index
                .bootstrapValidator('removeField', $row.find('[name="catidad[' + index2 + ']"]'));
        $row.remove();//elimina todo el div de atributo data-field-index

    }).on('success.form.bv', function(form){
    	if ( ComprobarAbonos() == false ) {
            $.alert('Los abonos de factura no concuerdan con el deposito ingresado');
            return false;
        }
        $('#Guardar_Deposito').button('loading');
        form.preventDefault();
        var $form = $(form.target);
		var form = $('#Form_Deposito')[0];
		var formData = new FormData(form);
		$.ajax({
			url: "guardar.php",
			type: "POST",
			data:  formData,
			contentType: false,
			cache: false,
			processData:false,
			success: function(result){
				$('#Guardar_Deposito').button('reset');
				$form.bootstrapValidator('resetForm', true);
				$("#Form_Deposito")[0].reset();
				$("#Modal_Deposito").modal('hide');
				$("#box_table").html(result)
				$("#clear_input").hide();
				Tabla_Simple('#tabla_deposito','',[false,false,25,false],'');
				$("#btn_imagenes").html('<i class="fa  fa-upload"></i> Agregar archivo&hellip;')
			}
		});
	});

});
