/*Tabla con multiples filtros en encabezadao usando la libreria DataTable y extensiones del mismo
AUTOR: ING. MANUEL GABRIEL
GUATEMALA
Tabla_Filter(TABLA,COLUMNAS_CON_SELECT,SUMAR_COLUMNA,ESTILO_PARA_INPUT,PAGIN_&&_INFO,BOTON_RESET_FILTER)
PARAMETROS:
TABLA -> id de la tabla para aplicar la funcion DataTable
COLUMNAS_CON_SELECT -> array de las columnas para aplicar input select, por numero de columna
SUMAR_COLUMNA -> array de tres valores. 1.Numero de columna a sumar 2.id de elemento para mostrar el total 3.simbolo de moneda
ESTILO_PARA_INPUT -> estilo para aplicar a input`s y select
PAGIN_&&_INFO -> array (False o True) para funcion paginacion y info de DataTable
BOTON_RESET_FILTER -> Boton para resetear filtros de tabla
EJEMPLO:
Tabla_Filter("#example",[4,6,7],[5,"#total","Q "],"datafilter",[true,true],"#limpiar");
*/

function Tabla_Filter(element,select,sum=null,clasinput,option,IdReset){
    //agrega input en thead de la tabla
    $(element+' thead th').each(function(){
        title = $(element+' thead th').eq($(this).index()).text();
        $(this).html(title+'<input type="text" class="'+clasinput+'" />');
    });    

    //Inicia la funcion DataTable
    var table = $(element).DataTable({
        responsive: true,
        paging: option[0],
        "lengthMenu": [[10, 25, 50, -1], [10, 25, 50, "Todo"]],
        info: option[1],
       
        
        drawCallback: function(){
            //verifica si el parametro sum no esta vacio para realizar la suma
            if (sum != null || sum.length < 2) {
                var api = this.api();
                //la funcion $.number pertenece a la libreria juery.number.min 
                var total_suma = $.number(api.column(sum[0], {page:'current'}).data().sum() , 2 , ".", ",");
                $(sum[1]).html("Q" + total_suma );
            }
        },  

        initComplete: function () {
            this.api().columns(select).every( function(){
                var column = this;
                //obtiene el titulo del encabezado de la columna
                var titulo = $(element+' thead th').eq(column.index()).text();
                //limpia el encabezado de la columna 
                $(element+' thead th').eq(column.index()).empty().append(titulo);

                var selects = $('<select class="'+clasinput+'"><option value=""></option></select>')
                .appendTo($(column.header())).on( 'change', function(){
                    var val = $.fn.dataTable.util.escapeRegex($(this).val());
                    column.search( val ? '^'+val+'$' : '', true, false ).draw();
                });

                column.data().unique().sort().each( function ( d, j ){
                    selects.append('<option value="'+d+'">'+d+'</option>')
                });
               
            });
        }
    });//Finaliza la funcion DataTable

    // aplica la busqueda introducida en el input o select
    table.columns().eq(0).each(function(colIdx){
        $('input', table.column(colIdx).header()).on('keyup change', function() {
            table
            .column(colIdx)
            .search(this.value)
            .draw();
        });

        $('input', table.column(colIdx).header()).on('click', function(e) {
            e.stopPropagation();
        });

        $('select', table.column(colIdx).header()).on('click', function(e) {
            e.stopPropagation();
        });
    });

    $(IdReset).click(function(){
       table.search('').columns().search('').draw();
       $("."+clasinput).val('');
    });

    if (table) {
        $(element).css({ opacity: 1 });
        $("#load_table").hide();
    }
};

//simple tabla con formato DataTable 
//funcion Tabla_Simple(IdTabla,Columa_a_sumar,optciones[info,paginacion,tamano_tabla,input_search],IdBotonReset)
function Tabla_Simple(element,sum=null,option,IdReset=null){
    var tabla = $(element).DataTable({
        "responsive": true,
        "pagingType": "numbers",
        "info":option[0],
        "paging":option[1],
        "lengthMenu": [[25, 50, -1], [25, 50, "Todo"]],
        "pageLength": option[2],
        "searching": option[3],
        drawCallback: function(){
            //verifica si el parametro sum no esta vacio para realizar la suma
            if (sum != null || sum.length < 2) {
                var api = this.api();
                //la funcion $.number pertenece a la libreria juery.number.min 
                var total_suma = $.number(api.column(sum[0], {page:'current'}).data().sum() , 2, '.', ',');
                $(sum[1]).html(sum[2] + total_suma );
            }
        }
    });
    $(IdReset).click(function(){
       tabla.search('').columns().search('').draw();
    });
    if (tabla) {
        $(element).css({ opacity: 1 });
        $("#load_table").hide();
         $(".load_table").hide();
    }
};